using Deskcandy.Candy;

namespace Deskcandy {
  [GtkTemplate(ui = "/moe/solarpunk/Deskcandy/screensaver_form.ui")]
  public class ScreensaverForm : Gtk.Bin {
    [GtkChild]
    private unowned Gtk.ListStore screensavers_liststore;
    [GtkChild]
    private unowned Gtk.Box screensaver_form_container;

    private unowned XScreensaver xss;

    private Gtk.Box config_items;

    public void on_initialized(XScreensaver xss) {
      this.xss = xss;

      Gtk.TreeIter iter;
      this.screensavers_liststore.clear();
      foreach (var config in xss.configs.values) {
        this.screensavers_liststore.append(out iter);
        this.screensavers_liststore.set(iter, 0, config.label, 1, config.description, 2, config.name);
      }
    }

    [GtkCallback]
    private void on_screensaver_chooser_row_activated(Gtk.TreeView treeview, Gtk.TreePath path, Gtk.TreeViewColumn col) {
      Gtk.TreeIter iter;
      string name;
      if (!treeview.model.get_iter(out iter, path)) {
        warning("can't find path in model?");
        return;
      }

      treeview.model.get(iter, 2, out name);
      this.xss.name = name;

      if (this.config_items != null) {
        this.screensaver_form_container.remove(this.config_items);
      }

      this.config_items = this.xss.configs.get(name).get_widgets();
      this.screensaver_form_container.pack_start(this.config_items, false);
      this.screensaver_form_container.show_all();
    }
  }
}
